//+------------------------------------------------------------------+
//|                                                ManualExpert.mq4  |
//|                         Auto Order Management For Manual Trades  |
//|                          Trailing Take Profit and Trailing Stop  |
//|                                                   (by NiteUser)  |
//+------------------------------------------------------------------+
#property copyright "(c) 2010 Niteuser"
#property link      "niteuser4u@gmail.com"

//+------------------------------------------------------------------+
extern int MoveTP=50;      //                                       |
extern bool UpDown=true;    //                                       |
//                                                                   |
//+------------------------------------------------------------------+

extern double  LotSize=0.1;
extern bool   ProfitTrailing = True;  
extern int    TrailingStop   = 6;    
extern int    TrailingStep   = 2;    
int            MagicNumber=1001;
extern bool    OpenATrade=false;
extern double  BuyPrice=0;
extern double  SellPrice=0;
extern int     FirstTPTarget=20;
extern int     StopLoss=20;
extern bool   UseSound       = False; 
extern string NameFileSound  = "expert.wav"; 

int orderType = 0;
int ticket = 0;

bool openBuy() 
{ 
   ticket = OrderSend(Symbol(),OP_BUY,LotSize,Ask,3,(BuyPrice-(Point*(StopLoss + 10))),(BuyPrice+(Point*(FirstTPTarget+10))),"",MagicNumber,0,Green);       
   if(ticket<1)
   {
      return(false);
   }

   orderType = OP_BUY;   

   return(true); 
} 


bool openSell() 
{ 
   ticket = OrderSend(Symbol(),OP_SELL,LotSize,Bid,3,(SellPrice+(Point*(StopLoss+10))),(SellPrice-(Point*(FirstTPTarget+10))),"",MagicNumber,0,Red);
   if(ticket<1)
   {
      return(false);
   }
   
   orderType = OP_SELL;  

   return(true); 
  
}



void start() 
{
if(IsWorkingOrder())
      {
         OpenATrade = false;          
      }
      else
      {
         
         if (OpenATrade == true)
         {
            if ((BuyPrice != 0)  &&  (SellPrice  != 0))
            Comment("\n","My Manual Trade Manager","\n","Waiting to Open A Trade" ,"\n","Buy at ",BuyPrice,"\n","Sell at ",SellPrice);      
         
            if ((BuyPrice != 0)  &&  (SellPrice  == 0))
            Comment("\n","My Manual Trade Manager","\n","Waiting to Open A Trade" ,"\n","Buy at ",BuyPrice);      
            
            if ((BuyPrice == 0)  &&  (SellPrice  != 0))
            Comment("\n","My Manual Trade Manager","\n","Waiting to Open A Trade" ,"\n","Sell at ",SellPrice);      
         
         }
         
         
         if (OpenATrade != true)
         Comment("\n","My Manual Trade Manager","\n","Not Looking for a Trade Right Now ");      
     
         
         
         
         if ((BuyPrice != 0)  &&  (Ask >= BuyPrice)  &&  (OpenATrade == true))         
            {
            OpenATrade = false;
            openBuy();
                     
         }
         if ((SellPrice != 0)  &&  (Bid <= SellPrice)  &&  (OpenATrade == true))         
         {
            OpenATrade = false;
            openSell();
         }
      }        
//-------------------------------------
double NewPrice;
int    i,Total,Dist;
int    Dgts=MarketInfo(Symbol(),MODE_DIGITS);     
bool   GoGo;
//+------------------------------------+
//  if(Distance<10) Dist=10;
//  else 
    Dist=MoveTP;
//+------------------------------------------------------------------+
  Total=OrdersTotal();
  if(Total>0)
  {
     for(i=Total-1; i>=0; i--) 
     {
        if(OrderSelect(i, SELECT_BY_POS, MODE_TRADES)==true) 
        {
           
           if(OrderSymbol()==Symbol() && OrderType()==OP_SELL && OrderMagicNumber()== MagicNumber) 
           {
              NewPrice=Bid-Dist*Point;
              if(UpDown==true) GoGo=true;
              else
              {
                 if(OrderTakeProfit()<NewPrice) GoGo=true;
                 else GoGo=false;
              }
              if(GoGo==true) if(OrderModify(OrderTicket(),
                             OrderOpenPrice(),
                             OrderStopLoss(),
                             NormalizeDouble(NewPrice,Dgts),
                             OrderExpiration(),
                             CLR_NONE)!=TRUE) 
                             Print("LastError = ", GetLastError());
                             TrailingPositions();
           }
           if(OrderSymbol()==Symbol() && OrderType()==OP_BUY && OrderMagicNumber()== MagicNumber) 
           {
              NewPrice=Ask+Dist*Point;
              if(UpDown==true) GoGo=true;
              else
              {
                 if(OrderTakeProfit()>NewPrice) GoGo=true;
                 else GoGo=false;
              }
              if(GoGo==true) if(OrderModify(OrderTicket(),
                             OrderOpenPrice(),
                             OrderStopLoss(),
                             NormalizeDouble(NewPrice,Dgts),
                             OrderExpiration(),
                             CLR_NONE)!=TRUE) 
                             Print("LastError = ", GetLastError());
                             TrailingPositions();
           }
        }
     }
  }
}
//+------------------------------------------------------------------+
void TrailingPositions() {
  double pBid, pAsk, pp;

  pp = MarketInfo(OrderSymbol(), MODE_POINT);
  if (OrderType()==OP_BUY && OrderMagicNumber()== MagicNumber) {
    pBid = MarketInfo(OrderSymbol(), MODE_BID);
    if (!ProfitTrailing || (pBid-OrderOpenPrice())>TrailingStop*pp) {
      if (OrderStopLoss()<pBid-(TrailingStop+TrailingStep-1)*pp) {
        ModifyStopLoss(pBid-TrailingStop*pp);
        return;
      }
    }
  }
  if (OrderType()==OP_SELL && OrderMagicNumber()== MagicNumber) {
    pAsk = MarketInfo(OrderSymbol(), MODE_ASK);
    if (!ProfitTrailing || OrderOpenPrice()-pAsk>TrailingStop*pp) {
      if (OrderStopLoss()>pAsk+(TrailingStop+TrailingStep-1)*pp || OrderStopLoss()==0) {
        ModifyStopLoss(pAsk+TrailingStop*pp);
        return;
      }
    }
  }
}

void ModifyStopLoss(double ldStopLoss) {
  bool fm;

  fm=OrderModify(OrderTicket(),OrderOpenPrice(),ldStopLoss,OrderTakeProfit(),0,CLR_NONE);
  if (fm && UseSound) PlaySound(NameFileSound);
}
//+------------------------------------------------------------------+
bool IsWorkingOrder()
  {
   int total = OrdersTotal();
   for(int cnt = 0; cnt < total; cnt++)
   {
      OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);
      if((OrderSymbol() == Symbol()) && (OrderMagicNumber() == MagicNumber))
         return(true);
   }
   return (false);
  }

